local YurrCombatLog = LibStub("AceAddon-3.0"):GetAddon("YurrCombatLog")
local L = LibStub("AceLocale-3.0"):GetLocale("YurrCombatLog")

local defaults = {
	profile = {
		
		ChatFrame = 2,
		timestamp = true,
		
		allSource = {
			Player = true,
		},
		allDestination = {
			Player = true,
		},
		
		filters = {
			Player = {
				source = {
					SWING_DAMAGE = true,
					SWING_MISSED = true,
					RANGE_DAMAGE = true,
					RANGE_MISSED = true,
					SPELL_DAMAGE = true,
					SPELL_MISSED = true,
					SPELL_HEAL = true,
					SPELL_ENERGIZE = true,
					SPELL_PERIODIC_MISSED = true,
					SPELL_PERIODIC_DAMAGE = true,
					SPELL_PERIODIC_HEAL = true,
					SPELL_PERIODIC_DRAIN = true,
					SPELL_PERIODIC_LEECH = true,
					SPELL_PERIODIC_ENERGIZE = true,
					SPELL_DRAIN = true,
					SPELL_LEECH = true,
					SPELL_INTERRUPT = true,
					SPELL_EXTRA_ATTACKS = true,
					--SPELL_INSTAKILL = false,
					--SPELL_DURABILITY_DAMAGE = false,
					--SPELL_DURABILITY_DAMAGE_ALL = false,
					SPELL_DISPELL = true,
					SPELL_STOLEN = true,
					--SPELL_AURA_APPLIED = true,
					--SPELL_AURA_REMOVED = true,
					--SPELL_AURA_APPLIED_DOSE = true,
					--SPELL_AURA_REMOVED_DOSE = true,
					--SPELL_CAST_START = false,
					--SPELL_CAST_SUCCESS = false,
					SPELL_CAST_FAILED = false,
					DAMAGE_SHIELD = true,
					--DAMAGE_SPLIT = false,
					DAMAGE_SHIELD_MISSED = true,
					ENCHANT_APPLIED = true,
					ENCHANT_REMOVED = true,
					PARTY_KILL = true,
					UNIT_DESTROYED = true,
					UNIT_DIED = true,
					ENVIRONMENTAL_DAMAGE = true,
				},
				destination = {
					SWING_DAMAGE = true,
					SWING_MISSED = true,
					RANGE_DAMAGE = true,
					RANGE_MISSED = true,
					SPELL_DAMAGE = true,
					SPELL_MISSED = true,
					SPELL_HEAL = true,
					SPELL_ENERGIZE = true,
					SPELL_PERIODIC_MISSED = true,
					SPELL_PERIODIC_DAMAGE = true,
					SPELL_PERIODIC_HEAL = true,
					SPELL_PERIODIC_DRAIN = true,
					SPELL_PERIODIC_LEECH = true,
					SPELL_PERIODIC_ENERGIZE = true,
					SPELL_DRAIN = true,
					SPELL_LEECH = true,
					SPELL_INTERRUPT = true,
					SPELL_EXTRA_ATTACKS = true,
					--SPELL_INSTAKILL = false,
					--SPELL_DURABILITY_DAMAGE = false,
					--SPELL_DURABILITY_DAMAGE_ALL = false,
					SPELL_DISPELL = true,
					SPELL_STOLEN = true,
					SPELL_AURA_APPLIED = true,
					SPELL_AURA_REMOVED = true,
					SPELL_AURA_APPLIED_DOSE = true,
					SPELL_AURA_REMOVED_DOSE = true,
					--SPELL_CAST_START = false,
					--SPELL_CAST_SUCCESS = false,
					--SPELL_CAST_FAILED = false,
					DAMAGE_SHIELD = true,
					--DAMAGE_SPLIT = false,
					DAMAGE_SHIELD_MISSED = true,
					ENCHANT_APPLIED = true,
					ENCHANT_REMOVED = true,
					PARTY_KILL = true,
					UNIT_DESTROYED = true,
					UNIT_DIED = true,
					ENVIRONMENTAL_DAMAGE = true,
				},
			},
			Pet = {
				source = {
					SWING_DAMAGE = false,
					SWING_MISSED = false,
					RANGE_DAMAGE = false,
					RANGE_MISSED = false,
					SPELL_DAMAGE = false,
					SPELL_MISSED = false,
					SPELL_HEAL = false,
					SPELL_ENERGIZE = false,
					SPELL_PERIODIC_MISSED = false,
					SPELL_PERIODIC_DAMAGE = false,
					SPELL_PERIODIC_HEAL = false,
					SPELL_PERIODIC_DRAIN = false,
					SPELL_PERIODIC_LEECH = false,
					SPELL_PERIODIC_ENERGIZE = false,
					SPELL_DRAIN = false,
					SPELL_LEECH = false,
					SPELL_INTERRUPT = false,
					SPELL_EXTRA_ATTACKS = false,
					SPELL_INSTAKILL = false,
					SPELL_DURABILITY_DAMAGE = false,
					SPELL_DURABILITY_DAMAGE_ALL = false,
					SPELL_DISPELL = false,
					SPELL_STOLEN = false,
					SPELL_AURA_APPLIED = false,
					SPELL_AURA_REMOVED = false,
					SPELL_AURA_APPLIED_DOSE = false,
					SPELL_AURA_REMOVED_DOSE = false,
					SPELL_CAST_START = false,
					SPELL_CAST_SUCCESS = false,
					SPELL_CAST_FAILED = false,
					DAMAGE_SHIELD = false,
					DAMAGE_SPLIT = false,
					DAMAGE_SHIELD_MISSED = false,
					ENCHANT_APPLIED = false,
					ENCHANT_REMOVED = false,
					PARTY_KILL = false,
					UNIT_DESTROYED = false,
					UNIT_DIED = false,
					ENVIRONMENTAL_DAMAGE = false,
				},
				destination = {
					SWING_DAMAGE = false,
					SWING_MISSED = false,
					RANGE_DAMAGE = false,
					RANGE_MISSED = false,
					SPELL_DAMAGE = false,
					SPELL_MISSED = false,
					SPELL_HEAL = false,
					SPELL_ENERGIZE = false,
					SPELL_PERIODIC_MISSED = false,
					SPELL_PERIODIC_DAMAGE = false,
					SPELL_PERIODIC_HEAL = false,
					SPELL_PERIODIC_DRAIN = false,
					SPELL_PERIODIC_LEECH = false,
					SPELL_PERIODIC_ENERGIZE = false,
					SPELL_DRAIN = false,
					SPELL_LEECH = false,
					SPELL_INTERRUPT = false,
					SPELL_EXTRA_ATTACKS = false,
					SPELL_INSTAKILL = false,
					SPELL_DURABILITY_DAMAGE = false,
					SPELL_DURABILITY_DAMAGE_ALL = false,
					SPELL_DISPELL = false,
					SPELL_STOLEN = false,
					SPELL_AURA_APPLIED = false,
					SPELL_AURA_REMOVED = false,
					SPELL_AURA_APPLIED_DOSE = false,
					SPELL_AURA_REMOVED_DOSE = false,
					SPELL_CAST_START = false,
					SPELL_CAST_SUCCESS = false,
					SPELL_CAST_FAILED = false,
					DAMAGE_SHIELD = false,
					DAMAGE_SPLIT = false,
					DAMAGE_SHIELD_MISSED = false,
					ENCHANT_APPLIED = false,
					ENCHANT_REMOVED = false,
					PARTY_KILL = false,
					UNIT_DESTROYED = false,
					UNIT_DIED = false,
					ENVIRONMENTAL_DAMAGE = false,
				},
			},
			Guardian = {
				source = {
					SWING_DAMAGE = false,
					SWING_MISSED = false,
					RANGE_DAMAGE = false,
					RANGE_MISSED = false,
					SPELL_DAMAGE = false,
					SPELL_MISSED = false,
					SPELL_HEAL = false,
					SPELL_ENERGIZE = false,
					SPELL_PERIODIC_MISSED = false,
					SPELL_PERIODIC_DAMAGE = false,
					SPELL_PERIODIC_HEAL = false,
					SPELL_PERIODIC_DRAIN = false,
					SPELL_PERIODIC_LEECH = false,
					SPELL_PERIODIC_ENERGIZE = false,
					SPELL_DRAIN = false,
					SPELL_LEECH = false,
					SPELL_INTERRUPT = false,
					SPELL_EXTRA_ATTACKS = false,
					SPELL_INSTAKILL = false,
					SPELL_DURABILITY_DAMAGE = false,
					SPELL_DURABILITY_DAMAGE_ALL = false,
					SPELL_DISPELL = false,
					SPELL_STOLEN = false,
					SPELL_AURA_APPLIED = false,
					SPELL_AURA_REMOVED = false,
					SPELL_AURA_APPLIED_DOSE = false,
					SPELL_AURA_REMOVED_DOSE = false,
					SPELL_CAST_START = false,
					SPELL_CAST_SUCCESS = false,
					SPELL_CAST_FAILED = false,
					DAMAGE_SHIELD = false,
					DAMAGE_SPLIT = false,
					DAMAGE_SHIELD_MISSED = false,
					ENCHANT_APPLIED = false,
					ENCHANT_REMOVED = false,
					PARTY_KILL = false,
					UNIT_DESTROYED = false,
					UNIT_DIED = false,
					ENVIRONMENTAL_DAMAGE = false,
				},
				destination = {
					SWING_DAMAGE = false,
					SWING_MISSED = false,
					RANGE_DAMAGE = false,
					RANGE_MISSED = false,
					SPELL_DAMAGE = false,
					SPELL_MISSED = false,
					SPELL_HEAL = false,
					SPELL_ENERGIZE = false,
					SPELL_PERIODIC_MISSED = false,
					SPELL_PERIODIC_DAMAGE = false,
					SPELL_PERIODIC_HEAL = false,
					SPELL_PERIODIC_DRAIN = false,
					SPELL_PERIODIC_LEECH = false,
					SPELL_PERIODIC_ENERGIZE = false,
					SPELL_DRAIN = false,
					SPELL_LEECH = false,
					SPELL_INTERRUPT = false,
					SPELL_EXTRA_ATTACKS = false,
					SPELL_INSTAKILL = false,
					SPELL_DURABILITY_DAMAGE = false,
					SPELL_DURABILITY_DAMAGE_ALL = false,
					SPELL_DISPELL = false,
					SPELL_STOLEN = false,
					SPELL_AURA_APPLIED = false,
					SPELL_AURA_REMOVED = false,
					SPELL_AURA_APPLIED_DOSE = false,
					SPELL_AURA_REMOVED_DOSE = false,
					SPELL_CAST_START = false,
					SPELL_CAST_SUCCESS = false,
					SPELL_CAST_FAILED = false,
					DAMAGE_SHIELD = false,
					DAMAGE_SPLIT = false,
					DAMAGE_SHIELD_MISSED = false,
					ENCHANT_APPLIED = false,
					ENCHANT_REMOVED = false,
					PARTY_KILL = false,
					UNIT_DESTROYED = false,
					UNIT_DIED = false,
					ENVIRONMENTAL_DAMAGE = false,
				},
			},
			Party = {
				source = {
					SWING_DAMAGE = false,
					SWING_MISSED = false,
					RANGE_DAMAGE = false,
					RANGE_MISSED = false,
					SPELL_DAMAGE = false,
					SPELL_MISSED = false,
					SPELL_HEAL = false,
					SPELL_ENERGIZE = false,
					SPELL_PERIODIC_MISSED = false,
					SPELL_PERIODIC_DAMAGE = false,
					SPELL_PERIODIC_HEAL = false,
					SPELL_PERIODIC_DRAIN = false,
					SPELL_PERIODIC_LEECH = false,
					SPELL_PERIODIC_ENERGIZE = false,
					SPELL_DRAIN = false,
					SPELL_LEECH = false,
					SPELL_INTERRUPT = false,
					SPELL_EXTRA_ATTACKS = false,
					SPELL_INSTAKILL = false,
					SPELL_DURABILITY_DAMAGE = false,
					SPELL_DURABILITY_DAMAGE_ALL = false,
					SPELL_DISPELL = false,
					SPELL_STOLEN = false,
					SPELL_AURA_APPLIED = false,
					SPELL_AURA_REMOVED = false,
					SPELL_AURA_APPLIED_DOSE = false,
					SPELL_AURA_REMOVED_DOSE = false,
					SPELL_CAST_START = false,
					SPELL_CAST_SUCCESS = false,
					SPELL_CAST_FAILED = false,
					DAMAGE_SHIELD = false,
					DAMAGE_SPLIT = false,
					DAMAGE_SHIELD_MISSED = false,
					ENCHANT_APPLIED = false,
					ENCHANT_REMOVED = false,
					PARTY_KILL = false,
					UNIT_DESTROYED = false,
					UNIT_DIED = false,
					ENVIRONMENTAL_DAMAGE = false,
				},
				destination = {
					SWING_DAMAGE = false,
					SWING_MISSED = false,
					RANGE_DAMAGE = false,
					RANGE_MISSED = false,
					SPELL_DAMAGE = false,
					SPELL_MISSED = false,
					SPELL_HEAL = false,
					SPELL_ENERGIZE = false,
					SPELL_PERIODIC_MISSED = false,
					SPELL_PERIODIC_DAMAGE = false,
					SPELL_PERIODIC_HEAL = false,
					SPELL_PERIODIC_DRAIN = false,
					SPELL_PERIODIC_LEECH = false,
					SPELL_PERIODIC_ENERGIZE = false,
					SPELL_DRAIN = false,
					SPELL_LEECH = false,
					SPELL_INTERRUPT = false,
					SPELL_EXTRA_ATTACKS = false,
					SPELL_INSTAKILL = false,
					SPELL_DURABILITY_DAMAGE = false,
					SPELL_DURABILITY_DAMAGE_ALL = false,
					SPELL_DISPELL = false,
					SPELL_STOLEN = false,
					SPELL_AURA_APPLIED = false,
					SPELL_AURA_REMOVED = false,
					SPELL_AURA_APPLIED_DOSE = false,
					SPELL_AURA_REMOVED_DOSE = false,
					SPELL_CAST_START = false,
					SPELL_CAST_SUCCESS = false,
					SPELL_CAST_FAILED = false,
					DAMAGE_SHIELD = false,
					DAMAGE_SPLIT = false,
					DAMAGE_SHIELD_MISSED = false,
					ENCHANT_APPLIED = false,
					ENCHANT_REMOVED = false,
					PARTY_KILL = false,
					UNIT_DESTROYED = false,
					UNIT_DIED = false,
					ENVIRONMENTAL_DAMAGE = false,
				},
			},
			Raid = {
				source = {
					SWING_DAMAGE = false,
					SWING_MISSED = false,
					RANGE_DAMAGE = false,
					RANGE_MISSED = false,
					SPELL_DAMAGE = false,
					SPELL_MISSED = false,
					SPELL_HEAL = false,
					SPELL_ENERGIZE = false,
					SPELL_PERIODIC_MISSED = false,
					SPELL_PERIODIC_DAMAGE = false,
					SPELL_PERIODIC_HEAL = false,
					SPELL_PERIODIC_DRAIN = false,
					SPELL_PERIODIC_LEECH = false,
					SPELL_PERIODIC_ENERGIZE = false,
					SPELL_DRAIN = false,
					SPELL_LEECH = false,
					SPELL_INTERRUPT = false,
					SPELL_EXTRA_ATTACKS = false,
					SPELL_INSTAKILL = false,
					SPELL_DURABILITY_DAMAGE = false,
					SPELL_DURABILITY_DAMAGE_ALL = false,
					SPELL_DISPELL = false,
					SPELL_STOLEN = false,
					SPELL_AURA_APPLIED = false,
					SPELL_AURA_REMOVED = false,
					SPELL_AURA_APPLIED_DOSE = false,
					SPELL_AURA_REMOVED_DOSE = false,
					SPELL_CAST_START = false,
					SPELL_CAST_SUCCESS = false,
					SPELL_CAST_FAILED = false,
					DAMAGE_SHIELD = false,
					DAMAGE_SPLIT = false,
					DAMAGE_SHIELD_MISSED = false,
					ENCHANT_APPLIED = false,
					ENCHANT_REMOVED = false,
					PARTY_KILL = false,
					UNIT_DESTROYED = false,
					UNIT_DIED = false,
					ENVIRONMENTAL_DAMAGE = false,
				},
				destination = {
					SWING_DAMAGE = false,
					SWING_MISSED = false,
					RANGE_DAMAGE = false,
					RANGE_MISSED = false,
					SPELL_DAMAGE = false,
					SPELL_MISSED = false,
					SPELL_HEAL = false,
					SPELL_ENERGIZE = false,
					SPELL_PERIODIC_MISSED = false,
					SPELL_PERIODIC_DAMAGE = false,
					SPELL_PERIODIC_HEAL = false,
					SPELL_PERIODIC_DRAIN = false,
					SPELL_PERIODIC_LEECH = false,
					SPELL_PERIODIC_ENERGIZE = false,
					SPELL_DRAIN = false,
					SPELL_LEECH = false,
					SPELL_INTERRUPT = false,
					SPELL_EXTRA_ATTACKS = false,
					SPELL_INSTAKILL = false,
					SPELL_DURABILITY_DAMAGE = false,
					SPELL_DURABILITY_DAMAGE_ALL = false,
					SPELL_DISPELL = false,
					SPELL_STOLEN = false,
					SPELL_AURA_APPLIED = false,
					SPELL_AURA_REMOVED = false,
					SPELL_AURA_APPLIED_DOSE = false,
					SPELL_AURA_REMOVED_DOSE = false,
					SPELL_CAST_START = false,
					SPELL_CAST_SUCCESS = false,
					SPELL_CAST_FAILED = false,
					DAMAGE_SHIELD = false,
					DAMAGE_SPLIT = false,
					DAMAGE_SHIELD_MISSED = false,
					ENCHANT_APPLIED = false,
					ENCHANT_REMOVED = false,
					PARTY_KILL = false,
					UNIT_DESTROYED = false,
					UNIT_DIED = false,
					ENVIRONMENTAL_DAMAGE = false,
				},
			},
			Outsider = {
				source = {
					SWING_DAMAGE = false,
					SWING_MISSED = false,
					RANGE_DAMAGE = false,
					RANGE_MISSED = false,
					SPELL_DAMAGE = false,
					SPELL_MISSED = false,
					SPELL_HEAL = false,
					SPELL_ENERGIZE = false,
					SPELL_PERIODIC_MISSED = false,
					SPELL_PERIODIC_DAMAGE = false,
					SPELL_PERIODIC_HEAL = false,
					SPELL_PERIODIC_DRAIN = false,
					SPELL_PERIODIC_LEECH = false,
					SPELL_PERIODIC_ENERGIZE = false,
					SPELL_DRAIN = false,
					SPELL_LEECH = false,
					SPELL_INTERRUPT = false,
					SPELL_EXTRA_ATTACKS = false,
					SPELL_INSTAKILL = false,
					SPELL_DURABILITY_DAMAGE = false,
					SPELL_DURABILITY_DAMAGE_ALL = false,
					SPELL_DISPELL = false,
					SPELL_STOLEN = false,
					SPELL_AURA_APPLIED = false,
					SPELL_AURA_REMOVED = false,
					SPELL_AURA_APPLIED_DOSE = false,
					SPELL_AURA_REMOVED_DOSE = false,
					SPELL_CAST_START = false,
					SPELL_CAST_SUCCESS = false,
					SPELL_CAST_FAILED = false,
					DAMAGE_SHIELD = false,
					DAMAGE_SPLIT = false,
					DAMAGE_SHIELD_MISSED = false,
					ENCHANT_APPLIED = false,
					ENCHANT_REMOVED = false,
					PARTY_KILL = false,
					UNIT_DESTROYED = false,
					UNIT_DIED = false,
					ENVIRONMENTAL_DAMAGE = false,
				},
				destination = {
					SWING_DAMAGE = false,
					SWING_MISSED = false,
					RANGE_DAMAGE = false,
					RANGE_MISSED = false,
					SPELL_DAMAGE = false,
					SPELL_MISSED = false,
					SPELL_HEAL = false,
					SPELL_ENERGIZE = false,
					SPELL_PERIODIC_MISSED = false,
					SPELL_PERIODIC_DAMAGE = false,
					SPELL_PERIODIC_HEAL = false,
					SPELL_PERIODIC_DRAIN = false,
					SPELL_PERIODIC_LEECH = false,
					SPELL_PERIODIC_ENERGIZE = false,
					SPELL_DRAIN = false,
					SPELL_LEECH = false,
					SPELL_INTERRUPT = false,
					SPELL_EXTRA_ATTACKS = false,
					SPELL_INSTAKILL = false,
					SPELL_DURABILITY_DAMAGE = false,
					SPELL_DURABILITY_DAMAGE_ALL = false,
					SPELL_DISPELL = false,
					SPELL_STOLEN = false,
					SPELL_AURA_APPLIED = false,
					SPELL_AURA_REMOVED = false,
					SPELL_AURA_APPLIED_DOSE = false,
					SPELL_AURA_REMOVED_DOSE = false,
					SPELL_CAST_START = false,
					SPELL_CAST_SUCCESS = false,
					SPELL_CAST_FAILED = false,
					DAMAGE_SHIELD = false,
					DAMAGE_SPLIT = false,
					DAMAGE_SHIELD_MISSED = false,
					ENCHANT_APPLIED = false,
					ENCHANT_REMOVED = false,
					PARTY_KILL = false,
					UNIT_DESTROYED = false,
					UNIT_DIED = false,
					ENVIRONMENTAL_DAMAGE = false,
				},
			},
			Target = {
				source = {
					SWING_DAMAGE = false,
					SWING_MISSED = false,
					RANGE_DAMAGE = false,
					RANGE_MISSED = false,
					SPELL_DAMAGE = false,
					SPELL_MISSED = false,
					SPELL_HEAL = false,
					SPELL_ENERGIZE = false,
					SPELL_PERIODIC_MISSED = false,
					SPELL_PERIODIC_DAMAGE = false,
					SPELL_PERIODIC_HEAL = false,
					SPELL_PERIODIC_DRAIN = false,
					SPELL_PERIODIC_LEECH = false,
					SPELL_PERIODIC_ENERGIZE = false,
					SPELL_DRAIN = false,
					SPELL_LEECH = false,
					SPELL_INTERRUPT = false,
					SPELL_EXTRA_ATTACKS = false,
					SPELL_INSTAKILL = false,
					SPELL_DURABILITY_DAMAGE = false,
					SPELL_DURABILITY_DAMAGE_ALL = false,
					SPELL_DISPELL = false,
					SPELL_STOLEN = false,
					SPELL_AURA_APPLIED = false,
					SPELL_AURA_REMOVED = false,
					SPELL_AURA_APPLIED_DOSE = false,
					SPELL_AURA_REMOVED_DOSE = false,
					SPELL_CAST_START = false,
					SPELL_CAST_SUCCESS = false,
					SPELL_CAST_FAILED = false,
					DAMAGE_SHIELD = false,
					DAMAGE_SPLIT = false,
					DAMAGE_SHIELD_MISSED = false,
					ENCHANT_APPLIED = false,
					ENCHANT_REMOVED = false,
					PARTY_KILL = false,
					UNIT_DESTROYED = false,
					UNIT_DIED = false,
					ENVIRONMENTAL_DAMAGE = false,
				},
				destination = {
					SWING_DAMAGE = false,
					SWING_MISSED = false,
					RANGE_DAMAGE = false,
					RANGE_MISSED = false,
					SPELL_DAMAGE = false,
					SPELL_MISSED = false,
					SPELL_HEAL = false,
					SPELL_ENERGIZE = false,
					SPELL_PERIODIC_MISSED = false,
					SPELL_PERIODIC_DAMAGE = false,
					SPELL_PERIODIC_HEAL = false,
					SPELL_PERIODIC_DRAIN = false,
					SPELL_PERIODIC_LEECH = false,
					SPELL_PERIODIC_ENERGIZE = false,
					SPELL_DRAIN = false,
					SPELL_LEECH = false,
					SPELL_INTERRUPT = false,
					SPELL_EXTRA_ATTACKS = false,
					SPELL_INSTAKILL = false,
					SPELL_DURABILITY_DAMAGE = false,
					SPELL_DURABILITY_DAMAGE_ALL = false,
					SPELL_DISPELL = false,
					SPELL_STOLEN = false,
					SPELL_AURA_APPLIED = false,
					SPELL_AURA_REMOVED = false,
					SPELL_AURA_APPLIED_DOSE = false,
					SPELL_AURA_REMOVED_DOSE = false,
					SPELL_CAST_START = false,
					SPELL_CAST_SUCCESS = false,
					SPELL_CAST_FAILED = false,
					DAMAGE_SHIELD = false,
					DAMAGE_SPLIT = false,
					DAMAGE_SHIELD_MISSED = false,
					ENCHANT_APPLIED = false,
					ENCHANT_REMOVED = false,
					PARTY_KILL = false,
					UNIT_DESTROYED = false,
					UNIT_DIED = false,
					ENVIRONMENTAL_DAMAGE = false,
				},
			},
			Focus = {
				source = {
					SWING_DAMAGE = false,
					SWING_MISSED = false,
					RANGE_DAMAGE = false,
					RANGE_MISSED = false,
					SPELL_DAMAGE = false,
					SPELL_MISSED = false,
					SPELL_HEAL = false,
					SPELL_ENERGIZE = false,
					SPELL_PERIODIC_MISSED = false,
					SPELL_PERIODIC_DAMAGE = false,
					SPELL_PERIODIC_HEAL = false,
					SPELL_PERIODIC_DRAIN = false,
					SPELL_PERIODIC_LEECH = false,
					SPELL_PERIODIC_ENERGIZE = false,
					SPELL_DRAIN = false,
					SPELL_LEECH = false,
					SPELL_INTERRUPT = false,
					SPELL_EXTRA_ATTACKS = false,
					SPELL_INSTAKILL = false,
					SPELL_DURABILITY_DAMAGE = false,
					SPELL_DURABILITY_DAMAGE_ALL = false,
					SPELL_DISPELL = false,
					SPELL_STOLEN = false,
					SPELL_AURA_APPLIED = false,
					SPELL_AURA_REMOVED = false,
					SPELL_AURA_APPLIED_DOSE = false,
					SPELL_AURA_REMOVED_DOSE = false,
					SPELL_CAST_START = false,
					SPELL_CAST_SUCCESS = false,
					SPELL_CAST_FAILED = false,
					DAMAGE_SHIELD = false,
					DAMAGE_SPLIT = false,
					DAMAGE_SHIELD_MISSED = false,
					ENCHANT_APPLIED = false,
					ENCHANT_REMOVED = false,
					PARTY_KILL = false,
					UNIT_DESTROYED = false,
					UNIT_DIED = false,
					ENVIRONMENTAL_DAMAGE = false,
				},
				destination = {
					SWING_DAMAGE = false,
					SWING_MISSED = false,
					RANGE_DAMAGE = false,
					RANGE_MISSED = false,
					SPELL_DAMAGE = false,
					SPELL_MISSED = false,
					SPELL_HEAL = false,
					SPELL_ENERGIZE = false,
					SPELL_PERIODIC_MISSED = false,
					SPELL_PERIODIC_DAMAGE = false,
					SPELL_PERIODIC_HEAL = false,
					SPELL_PERIODIC_DRAIN = false,
					SPELL_PERIODIC_LEECH = false,
					SPELL_PERIODIC_ENERGIZE = false,
					SPELL_DRAIN = false,
					SPELL_LEECH = false,
					SPELL_INTERRUPT = false,
					SPELL_EXTRA_ATTACKS = false,
					SPELL_INSTAKILL = false,
					SPELL_DURABILITY_DAMAGE = false,
					SPELL_DURABILITY_DAMAGE_ALL = false,
					SPELL_DISPELL = false,
					SPELL_STOLEN = false,
					SPELL_AURA_APPLIED = false,
					SPELL_AURA_REMOVED = false,
					SPELL_AURA_APPLIED_DOSE = false,
					SPELL_AURA_REMOVED_DOSE = false,
					SPELL_CAST_START = false,
					SPELL_CAST_SUCCESS = false,
					SPELL_CAST_FAILED = false,
					DAMAGE_SHIELD = false,
					DAMAGE_SPLIT = false,
					DAMAGE_SHIELD_MISSED = false,
					ENCHANT_APPLIED = false,
					ENCHANT_REMOVED = false,
					PARTY_KILL = false,
					UNIT_DESTROYED = false,
					UNIT_DIED = false,
					ENVIRONMENTAL_DAMAGE = false,
				},
			},
		},
		
		constants = {
			Player = 1297,
			Pet = 4991,
			Raid = 32532,
			Party = 32594,
			Target = 12136,
			Guardian = 8465,
			Focus = 131072,
			Outsider = 20248,
		},
		
		flags = {
			Player = {
				["1"] = "1",
				["16"] = "16",
				["256"] = "256",
				["1024"] = "1024",
			},
		},
		
		events = {
			experience = true,
			faction = true,
			skill = true,
			honor = true,
		},
		
		watches = {
		},
		
		colors = {
			player = {
				["r"] = 0.50,
				["g"] = 0.50,
				["b"] = 1.00,
			},
			pet = {
				["r"] = 0.50,
				["g"] = 0.30,
				["b"] = 0.15,
			},
			raid = {
				["r"] = 1.00,
				["g"] = 0.44,
				["b"] = 0.20,
			},
			party = {
				["r"] = 0.65,
				["g"] = 1.00,
				["b"] = 0.65,
			},
			target = {
				["r"] = 1.00,
				["g"] = 0.46,
				["b"] = 1.00,
			},
			guardian = {
				["r"] = 0.25,
				["g"] = 0.25,
				["b"] = 0.50,
			},
			focus = {
				["r"] = 0.80,
				["g"] = 0.33,
				["b"] = 0.85,
			},
			Outsider = {
				["r"] = 1.00,
				["g"] = 1.00,
				["b"] = 1.00,
			},
			physical = {
				["r"] = 1.00,
				["g"] = 1.00,
				["b"] = 1.00,
			},
			holy = {
				["r"] = 1.00,
				["g"] = 1.00,
				["b"] = 0.30,
			},
			fire = {
				["r"] = 1.00,
				["g"] = 0.15,
				["b"] = 0.18,
			},
			nature = {
				["r"] = 0.40,
				["g"] = 1.00,
				["b"] = 0.40,
			},
			frost = {
				["r"] = 0.30,
				["g"] = 0.30,
				["b"] = 0.90,
			},
			shadow = {
				["r"] = 1.00,
				["g"] = 0.70,
				["b"] = 1.00,
			},
			arcane = {
				["r"] = 0.75,
				["g"] = 0.75,
				["b"] = 0.75,
			},
			natureshadow = {
				["r"] = 0.70,
				["g"] = 0.85,
				["b"] = 0.70,
			},
			heal = {
				["r"] = 1.00,
				["g"] = 1.00,
				["b"] = 0.30,
			},
			miss = {
				["r"] = 1.00,
				["g"] = 0.5,
				["b"] = 0.5,
			},
			buff = {
				["r"] = 0.20,
				["g"] = 1.00,
				["b"] = 0.20,
			},
			debuff = {
				["r"] = 1.00,
				["g"] = 0.20,
				["b"] = 0.20,
			},
			skill = {
				["r"] = 1.00,
				["g"] = 1.00,
				["b"] = 0.4,
			},
			timestampColor = {
				r = 0.45,
				g = 0.45,
				b = 0.45,
			},
		},
		
		miniMap = {
		dragable = true,
		angle = 282,
		radius = 80,
		rounding = 10,
		Hidden = false
		}
	}
}

local options = {
	type = "group",
	name = "YurrCombatLog",
	childGroups = "tree",
	args = {
		YurrCombatLog = {
		type = "group",
		name = "YurrCombatLog",
		handler = YurrCombatLog,
			args = {
				general = {
					type = "group",
					name = "YurrCombatLog",
					order = 1,
					inline = true,
					args = {
						chatFrame = {
							type = "select",
							name = L["ChatFrame"],
							desc = "Select where you want your CombatLog output.",
							values = { "ChatFrame1", "ChatFrame2", "ChatFrame3", "ChatFrame4", "ChatFrame5", "ChatFrame6", "ChatFrame7" },
							get = function()
								return YurrCombatLog.db.profile.ChatFrame
							end,
							set = function(info, value)
								outputFrame = YurrCombatLog:ChatFrame(YurrCombatLog.db.profile.ChatFrame)
								YurrCombatLog.db.profile.ChatFrame = value
							end,
						},
						timestamp = {
							type = "toggle",
							name = "Timestamp",
							get = function()
								return YurrCombatLog.db.profile.timestamp
							end,
							set = function(info, value)
								YurrCombatLog.db.profile.timestamp = value
							end,
						},
						timestampColor = {
							type = "color",
							name = "Timestamp Color",
							get = "getColor",
							set = "setColor",
						},
					},
				},
				filters = {
				type = "group",
				order = 1,
				name = L["Filters"],
					args = {
						newFilter = {
							type = "input",
							order = 1,
							name = L["newFilter"],
							get = function()
								return
							end,
							set = "addFilter",
						},
						
					},
				},
				events = {
					type = "group",
					order = 2,
					name = L["Events"],
					args = {
						events = {
							type = "group",
							name = L["Events"],
							order = 1,
							inline = true,
							args = {
								experience = {
									type = "toggle",
									order = 1,
									name = L["Experience"],
									set = "setEvents",
									get = "getEvents",
								},
								combat = {
									type = "toggle",
									order = 1,
									name = L["Combat"],
									get = function()
									return YurrCombatLog.db.profile.events.combat
								end,
								set = function(info, value)
									YurrCombatLog.db.profile.events.combat = value
								end,
								},
								faction = {
									type = "toggle",
									order = 1,
									name = L["Faction"],
									get = function()
									return YurrCombatLog.db.profile.events.faction
								end,
								set = function(info, value)
									YurrCombatLog.db.profile.events.faction = value
								end,
								},
								skill = {
									type = "toggle",
									order = 1,
									name = L["Skill"],
									get = function()
									return YurrCombatLog.db.profile.events.skill
								end,
								set = function(info, value)
									YurrCombatLog.db.profile.events.skill = value
								end,
								},
								honor = {
									type = "toggle",
									order = 1,
									name = L["Honor"],
									get = function()
									return YurrCombatLog.db.profile.events.honor
								end,
								set = function(info, value)
									YurrCombatLog.db.profile.events.honor = value
								end,
								},
							},
						},
					},
				},
				colors = {
				type = "group",
				name = L["Colors"],
				order = 3,
					args = {
						Affiliation = {
						type = "group",
						name = L["Affiliation"],
						inline = true,
							args = {
								player = {
								type = "color",
								name = L["Player"],
								set = "setColor",
								get = "getColor",
								order = 1,
								},
								pet = {
								type = "color",
								name = L["Pet"],
								set = "setColor",
								get = "getColor",
								order = 2,
								},
								raid = {
								type = "color",
								name = L["Raid"],
								set = "setColor",
								get = "getColor",
								order = 3,
								},
								party = {
								type = "color",
								name = L["Party"],
								set = "setColor",
								get = "getColor",
								order = 4,
								},
								target = {
								type = "color",
								name = L["Target"],
								set = "setColor",
								get = "getColor",
								order = 5,
								},
								guardian = {
								type = "color",
								name = L["Guardian"],
								set = "setColor",
								get = "getColor",
								order = 6,
								},
								focus = {
								type = "color",
								name = L["Focus"],
								set = "setColor",
								get = "getColor",
								order = 7,
								},
								Outsider = {
								type = "color",
								name = L["Outsider"],
								set = "setColor",
								get = "getColor",
								order = 8,
								},
							}
						},
						School = {
						type = "group",
						name = L["School"],
						inline = true,
							args = {
								physical = {
								type = "color",
								name = L["Physical"],
								set = "setColor",
								get = "getColor",
								order = 1,
								},
								holy = {
								type = "color",
								name = L["Holy"],
								set = "setColor",
								get = "getColor",
								order = 2,
								},
								fire = {
								type = "color",
								name = L["Fire"],
								set = "setColor",
								get = "getColor",
								order = 3,
								},
								nature = {
								type = "color",
								name = L["Nature"],
								set = "setColor",
								get = "getColor",
								order = 4,
								},
								frost = {
								type = "color",
								name = L["Frost"],
								set = "setColor",
								get = "getColor",
								order = 5,
								},
								shadow = {
								type = "color",
								name = L["Shadow"],
								set = "setColor",
								get = "getColor",
								order = 6,
								},
								arcane = {
								type = "color",
								name = L["Arcane"],
								set = "setColor",
								get = "getColor",
								order = 7,
								},
								natureshadow = {
								type = "color",
								name = L["Nature+shadow"],
								set = "setColor",
								get = "getColor",
								order = 8,
								},
							}
						},
						Type = {
						type = "group",
						name = L["Type"],
						inline = true,
							args = {
								heal = {
								type = "color",
								name = L["Heal"],
								set = "setColor",
								get = "getColor",
								order = 1,
								},
								miss = {
								type = "color",
								name = L["Miss"],
								set = "setColor",
								get = "getColor",
								order = 2,
								},
								buff = {
								type = "color",
								name = L["Buff"],
								set = "setColor",
								get = "getColor",
								order = 3,
								},
								debuff = {
								type = "color",
								name = L["Debuff"],
								set = "setColor",
								get = "getColor",
								order = 4,
								},
								skill = {
								type = "color",
								name = L["Skill"],
								set = "setColor",
								get = "getColor",
								order = 5,
								},
							}
						}
					}
				},
--[[				format = {
					order = 4,
				},]]
				watches = {
					type = "group",
					name = L["Watches"],
					order = 5,
					args = {
						watches = {
							type = "group",
							name = L["Watches"],
							order = 1,
							inline = true,
							args = {
								addName = {
								type = "input",
								name = L["addName"],
								order = 1,
								set = function(info, value) YurrCombatLog.db.profile.watches[value] = value
								end,
								get = function() end,
								},
								removeName = {
								type = "input",
								name = L["removeName"],
								order = 2,
								set = function(info, value) YurrCombatLog.db.profile.watches[value] = nil
								end,
								get = function() end,
								},
								listnames = {
								type = "header",
								name = function()
									local newvalue = ""
									for key,value in pairs(YurrCombatLog.db.profile.watches) do newvalue = value..", "..newvalue end
									return newvalue
								end,
								order = 3,
								},
							},
						},
					},
				},
				minimap = {
					type = "group",
					name = L["Minimap Options"],
					order = 6,
					args = {
						minimap = {
							type = "group",
							name = L["Minimap Options"],
							order = 1,
							inline = true,
							args = {
								hideIcon = {
									type = "toggle",
									name = L["Hide minimap icon"],
									desc = L["Hide minimap icon"],
									get = function(info) 
										return YurrCombatLog.db.profile.miniMap.Hidden
									end,
									set = function(info, value)
										YurrCombatLog.db.profile.miniMap.Hidden = value
										if ( YurrCombatLog.db.profile.miniMap.Hidden == true ) then
											YurrCombatLog:HideMinimap()
										elseif ( YurrCombatLog.db.profile.miniMap.Hidden == false ) then
											YurrCombatLog:ShowMinimap()
										end
									end,
								},
							},
						},
					},
				},
				--[[profiles = {
					type = "group",
					name = "profiles",
					order = 7,
					args = {
						select = {
							type = "select",
							name = "profiles",
							values = function() return YurrCombatLog.db:GetProfiles() end,
							set = function(info, value) ChatFrame3:AddMessage(value) YurrCombatLog.db:SetProfile(value) end,
							get = function () end,
						},
					},
				},]]
			}
		}
	}
}

function YurrCombatLog:Config()

	self.db = LibStub("AceDB-3.0"):New("YurrCombatLogDB", defaults, "Default")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("YurrCombatLog", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("YurrCombatLog", "YurrCombatLog")
	self:ParseFilters()

end

function YurrCombatLog:ParseFilters()

	local COMBATLOG_OBJECT_AFFILIATION_MINE = tostring(COMBATLOG_OBJECT_AFFILIATION_MINE)
	local COMBATLOG_OBJECT_AFFILIATION_PARTY = tostring(COMBATLOG_OBJECT_AFFILIATION_PARTY)
	local COMBATLOG_OBJECT_AFFILIATION_RAID = tostring(COMBATLOG_OBJECT_AFFILIATION_RAID)
	local COMBATLOG_OBJECT_AFFILIATION_OUTSIDER = tostring(COMBATLOG_OBJECT_AFFILIATION_OUTSIDER)
	local COMBATLOG_OBJECT_REACTION_FRIENDLY = tostring(COMBATLOG_OBJECT_REACTION_FRIENDLY)
	local COMBATLOG_OBJECT_REACTION_NEUTRAL = tostring(COMBATLOG_OBJECT_REACTION_NEUTRAL)
	local COMBATLOG_OBJECT_REACTION_HOSTILE = tostring(COMBATLOG_OBJECT_REACTION_HOSTILE)
	local COMBATLOG_OBJECT_CONTROL_PLAYER = tostring(COMBATLOG_OBJECT_CONTROL_PLAYER)
	local COMBATLOG_OBJECT_CONTROL_NPC = tostring(COMBATLOG_OBJECT_CONTROL_NPC)
	local COMBATLOG_OBJECT_TYPE_PLAYER = tostring(COMBATLOG_OBJECT_TYPE_PLAYER)
	local COMBATLOG_OBJECT_TYPE_NPC = tostring(COMBATLOG_OBJECT_TYPE_NPC)
	local COMBATLOG_OBJECT_TYPE_PET = tostring(COMBATLOG_OBJECT_TYPE_PET)
	local COMBATLOG_OBJECT_TYPE_GUARDIAN = tostring(COMBATLOG_OBJECT_TYPE_GUARDIAN)
	local COMBATLOG_OBJECT_TYPE_OBJECT = tostring(COMBATLOG_OBJECT_TYPE_OBJECT)
	local COMBATLOG_OBJECT_TARGET = tostring(COMBATLOG_OBJECT_TARGET)
	local COMBATLOG_OBJECT_FOCUS = tostring(COMBATLOG_OBJECT_FOCUS)
	
	local filters = self.db.profile.filters
	for key in pairs(filters) do
		options.args.YurrCombatLog.args.filters.args[key] = {
			type = "group",
			name = key,
			childGroups = "tab",
			args = {
				[key] = {
					type = "header",
					name = L["Filters for "]..key,
					order = 1,
				},
				source = {
					type = "group",
					name = L["Source"],
					order = 2,
					args = {
						all = {
							type = "toggle",
							name = L["All"],
							order = 1,
							width = "full",
							set = function(info, value)
								local filters = self.db.profile.filters
								for key in pairs (filters[info[#info-2]][info[#info-1]]) do
									self.db.profile.filters[info[#info-2]][info[#info-1]][key] = value
									self.db.profile.allSource[info[#info-2]] = value
								end
							end,
							get = function(info) return self.db.profile.allSource[info[#info-2]] end
						},
						SWING_DAMAGE = {
							type = "toggle",
							name = L["Melee Damage"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SWING_MISSED = {
							type = "toggle",
							name = L["Melee Missed"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						RANGE_DAMAGE = {
							type = "toggle",
							name = L["Ranged Damage"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						RANGE_MISSED = {
							type = "toggle",
							name = L["Ranged Missed"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_DAMAGE = {
							type = "toggle",
							name = L["Spelldamage"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_MISSED = {
							type = "toggle",
							name = L["Spell resist"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						
						SPELL_HEAL = {
							type = "toggle",
							name = L["Healing"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_ENERGIZE = {
							type = "toggle",
							name = L["Spell energize"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_PERIODIC_MISSED = {
							type = "toggle",
							name = L["Spell periodic resist"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_PERIODIC_DAMAGE = {
							type = "toggle",
							name = L["Spell periodic damage"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_PERIODIC_HEAL = {
							type = "toggle",
							name = L["Spell periodic heals"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_PERIODIC_DRAIN = {
							type = "toggle",
							name = L["Spell periodic drain"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_PERIODIC_LEECH = {
							type = "toggle",
							name = L["Spell periodic leech"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_PERIODIC_ENERGIZE = {
							type = "toggle",
							name = L["Spell periodic energize"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_DRAIN = {
							type = "toggle",
							name = L["Drains"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_LEECH = {
							type = "toggle",
							name = L["Leech"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_INTERRUPT = {
							type = "toggle",
							name = L["Interrupts"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_EXTRA_ATTACKS = {
							type = "toggle",
							name = L["Extra Attacks"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						--SPELL_INSTAKILL
						--SPELL_DURABILITY_DAMAGE
						--SPELL_DURABILITY_DAMAGE_ALL
						SPELL_DISPELL = {
							type = "toggle",
							name = L["Dispels"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_STOLEN = {
							type = "toggle",
							name = L["Spellstolen"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_AURA_APPLIED = {
							type = "toggle",
							name = L["Buffs and Debuffs"],
							order = 1,
							disabled = true,
						},
						SPELL_AURA_REMOVED = {
							type = "toggle",
							name = L["Buffs/Debuffs removed"],
							order = 1,
							disabled = true,
						},
						SPELL_AURA_APPLIED_DOSE = {
							type = "toggle",
							name = L["Buffs/Debuffs (stacking)"],
							order = 1,
							disabled = true,
						},
						SPELL_AURA_REMOVED_DOSE = {
							type = "toggle",
							name = L["Buffs/Debuffs removed (stacking)"],
							order = 1,
							disabled = true,
						},
						--SPELL_CAST_START
						--SPELL_CAST_SUCCESS
						SPELL_CAST_FAILED = {
							type = "toggle",
							name = L["Failed"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						DAMAGE_SHIELD = {
							type = "toggle",
							name = L["Damage Shields"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						--DAMAGE_SPLIT
						DAMAGE_SHIELD_MISSED = {
							type = "toggle",
							name = L["Damage Shield resist"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						ENCHANT_APPLIED = {
							type = "toggle",
							name = L["Enchant applied"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						ENCHANT_REMOVED = {
							type = "toggle",
							name = L["Enchant removed"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						PARTY_KILL = {
							type = "toggle",
							name = L["Party/Raid kills"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						--UNIT_DESTROYED
						UNIT_DIED = {
							type = "toggle",
							name = L["Deaths"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						ENVIRONMENTAL_DAMAGE = {
							type = "toggle",
							name = L["Environment Damage"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
					},
				},
				destination = {
					type = "group",
					name = L["Destination"],
					order = 3,
					args = {
						all = {
							type = "toggle",
							name = L["All"],
							order = 1,
							width = "full",
							set = function(info, value)
								local filters = self.db.profile.filters
								for key in pairs (filters[info[#info-2]][info[#info-1]]) do
									self.db.profile.filters[info[#info-2]][info[#info-1]][key] = value
									self.db.profile.allDestination[info[#info-2]] = value
								end
							end,
							get = function(info) return self.db.profile.allDestination[info[#info-2]] end
						},
						SWING_DAMAGE = {
							type = "toggle",
							name = L["Melee Damage"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SWING_MISSED = {
							type = "toggle",
							name = L["Melee Missed"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						RANGE_DAMAGE = {
							type = "toggle",
							name = L["Ranged Damage"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						RANGE_MISSED = {
							type = "toggle",
							name = L["Ranged Missed"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_DAMAGE = {
							type = "toggle",
							name = L["Spelldamage"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_MISSED = {
							type = "toggle",
							name = L["Spell resist"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						
						SPELL_HEAL = {
							type = "toggle",
							name = L["Healing"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_ENERGIZE = {
							type = "toggle",
							name = L["Spell energize"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_PERIODIC_MISSED = {
							type = "toggle",
							name = L["Spell periodic resist"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_PERIODIC_DAMAGE = {
							type = "toggle",
							name = L["Spell periodic damage"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_PERIODIC_HEAL = {
							type = "toggle",
							name = L["Spell periodic heals"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_PERIODIC_DRAIN = {
							type = "toggle",
							name = L["Spell periodic drain"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_PERIODIC_LEECH = {
							type = "toggle",
							name = L["Spell periodic leech"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_PERIODIC_ENERGIZE = {
							type = "toggle",
							name = L["Spell periodic energize"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_DRAIN = {
							type = "toggle",
							name = L["Drains"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_LEECH = {
							type = "toggle",
							name = L["Leech"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_INTERRUPT = {
							type = "toggle",
							name = L["Interrupts"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_EXTRA_ATTACKS = {
							type = "toggle",
							name = L["Extra Attacks"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						--SPELL_INSTAKILL
						--SPELL_DURABILITY_DAMAGE
						--SPELL_DURABILITY_DAMAGE_ALL
						SPELL_DISPELL = {
							type = "toggle",
							name = L["Dispels"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_STOLEN = {
							type = "toggle",
							name = L["Spellstolen"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_AURA_APPLIED = {
							type = "toggle",
							name = L["Buffs and Debuffs"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_AURA_REMOVED = {
							type = "toggle",
							name = L["Buffs/Debuffs removed"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_AURA_APPLIED_DOSE = {
							type = "toggle",
							name = L["Buffs/Debuffs (stacking)"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						SPELL_AURA_REMOVED_DOSE = {
							type = "toggle",
							name = L["Buffs/Debuffs removed (stacking)"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						--SPELL_CAST_START
						--SPELL_CAST_SUCCESS
						SPELL_CAST_FAILED = {
							type = "toggle",
							name = L["Failed"],
							order = 1,
							disabled = true,
						},
						DAMAGE_SHIELD = {
							type = "toggle",
							name = L["Damage Shields"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						--DAMAGE_SPLIT
						DAMAGE_SHIELD_MISSED = {
							type = "toggle",
							name = L["Damage Shield resist"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						ENCHANT_APPLIED = {
							type = "toggle",
							name = L["Enchant applied"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						ENCHANT_REMOVED = {
							type = "toggle",
							name = L["Enchant removed"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						PARTY_KILL = {
							type = "toggle",
							name = L["Party/Raid kills"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						--UNIT_DESTROYED
						UNIT_DIED = {
							type = "toggle",
							name = L["Deaths"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
						ENVIRONMENTAL_DAMAGE = {
							type = "toggle",
							name = L["Environment Damage"],
							order = 1,
							set = "setFilter",
							get = "getFilter",
						},
					},
				},
				flags = {
					type = "group",
					name = L["Flags"],
					order = 4,
					args = {
						affiliation = {
							type = "group",
							name = L["Affiliation"],
							inline = true,
							order = 1,
							args = {
								[COMBATLOG_OBJECT_AFFILIATION_MINE] = {
									type = "toggle",
									name = "Player",
									set = "setFlags",
									get = "getFlags",
								},
								[COMBATLOG_OBJECT_AFFILIATION_PARTY] = {
									type = "toggle",
									name = "Party",
									set = "setFlags",
									get = "getFlags",
								},
								[COMBATLOG_OBJECT_AFFILIATION_RAID] = {
									type = "toggle",
									name = "Raid",
									set = "setFlags",
									get = "getFlags",
								},
								[COMBATLOG_OBJECT_AFFILIATION_OUTSIDER] = {
									type = "toggle",
									name = "Outsider",
									set = "setFlags",
									get = "getFlags",
								},
							},
						},
						reaction = {
							type = "group",
							name = L["Reaction"],
							inline = true,
							order = 2,
							args = {
								[COMBATLOG_OBJECT_REACTION_FRIENDLY] = {
									type = "toggle",
									name = "Friendly",
									set = "setFlags",
									get = "getFlags",
								},
								[COMBATLOG_OBJECT_REACTION_NEUTRAL] = {
									type = "toggle",
									name = "Neutral",
									set = "setFlags",
									get = "getFlags",
								},
								[COMBATLOG_OBJECT_REACTION_HOSTILE] = {
									type = "toggle",
									name = "Hostile",
									set = "setFlags",
									get = "getFlags",
								},
							},
						},
						Ownership = {
							type = "group",
							name = L["Ownership"],
							inline = true,
							order = 3,
							args = {
								[COMBATLOG_OBJECT_CONTROL_PLAYER] = {
									type = "toggle",
									name = "Player",
									set = "setFlags",
									get = "getFlags",
								},
								[COMBATLOG_OBJECT_CONTROL_NPC] = {
									type = "toggle",
									name = "NPC",
									set = "setFlags",
									get = "getFlags",
								},
							},
						},
						Unittype = {
							type = "group",
							name = L["Unit type"],
							inline = true,
							order = 4,
							args = {
								[COMBATLOG_OBJECT_TYPE_PLAYER] = {
									type = "toggle",
									name = "Player",
									set = "setFlags",
									get = "getFlags",
								},
								[COMBATLOG_OBJECT_TYPE_NPC] = {
									type = "toggle",
									name = "NPC",
									set = "setFlags",
									get = "getFlags",
								},
								[COMBATLOG_OBJECT_TYPE_PET] = {
									type = "toggle",
									name = "Pet",
									set = "setFlags",
									get = "getFlags",
								},
								[COMBATLOG_OBJECT_TYPE_GUARDIAN] = {
									type = "toggle",
									name = "Guardian",
									set = "setFlags",
									get = "getFlags",
								},
								[COMBATLOG_OBJECT_TYPE_OBJECT] = {
									type = "toggle",
									name = "Object",
									set = "setFlags",
									get = "getFlags",
								},
							},
						},
						Special = {
							type = "group",
							name = L["Special flags"],
							inline = true,
							order = 5,
							args = {
								[COMBATLOG_OBJECT_TARGET] = {
									type = "toggle",
									name = "Target",
									set = "setFlags",
									get = "getFlags",
								},
								[COMBATLOG_OBJECT_FOCUS] = {
									type = "toggle",
									name = "Focus",
									set = "setFlags",
									get = "getFlags",
								},
							},
						},
					},
				},
				removeFilter = {
					type = "execute",
					name = L["Remove this Filter"],
					order = 5,
					func = function(info)
						YurrCombatLog.db.profile.filters[info[#info-1]] = nil
						options.args.YurrCombatLog.args.filters.args[info[#info-1]] = nil
					end,
				}
			}
		}
	end
end
