YurrCombatLog = LibStub("AceAddon-3.0"):NewAddon("YurrCombatLog", "AceConsole-3.0", "AceEvent-3.0")
local YurrCombatLogLDB = LibStub("LibDataBroker-1.1")
local L = LibStub("AceLocale-3.0"):GetLocale("YurrCombatLog")
local Addon = LibStub("AceAddon-3.0"):GetAddon("Fortress", "silent")
local math_floor = _G.math.floor

local LDB = YurrCombatLogLDB:NewDataObject("YurrCombatLogLDB", {
	icon = "Interface\\Icons\\Ability_MeleeDamage",
	label = "YurrCombatLogLDB",
	text = "YurrCombatLog"
})

function LDB:OnEnter()
	GameTooltip:SetOwner(self, "ANCHOR_NONE")
	GameTooltip:SetPoint("TOP", self, "BOTTOM")
	GameTooltip:ClearLines()
	GameTooltip:AddLine(LDB.text)
	GameTooltip:AddLine("|cffffff00"..L["LeftClick|r to open the YurrCombatLog options menu"])
	if ( Addon ) then
		GameTooltip:AddLine("|cffffff00"..L["RightClick|r to open the Fotress options menu"])
	end
	--LDB.OnTooltipShow(GameTooltip)
	GameTooltip:Show()
end

function LDB:OnClick(button)
	if button == "LeftButton" then
		LibStub("AceConfigDialog-3.0"):Open("YurrCombatLog")
	elseif ( Addon ) and button == "RightButton" then
		LibStub("AceConfigDialog-3.0"):Open("YurrCombatLogLDB")
	end
end

function LDB:OnLeave()
    GameTooltip:Hide()
end

function YurrCombatLog:OnInitialize()

	-- Called when the addon is loaded
	self:Config()
	self:Minimap()
	self:RegisterChatCommand("ycl", "ChatCommand")
	self:RegisterChatCommand("yurrcombatlog", "ChatCommand")

end

function YurrCombatLog:OnEnable()

	-- Called when the addon is enabled
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:RegisterEvent("CHAT_MSG_COMBAT_XP_GAIN")
	self:RegisterEvent("CHAT_MSG_COMBAT_HONOR_GAIN")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE")
	self:RegisterEvent("ADDON_LOADED")
	self:RegisterEvent("CHAT_MSG_SKILL")
	outputFrame = self:ChatFrame(self.db.profile.ChatFrame)
	CombatLogQuickButtonFrame_Custom:Hide()
	Blizzard_CombatLog_AdjustCombatLogHeight = fakeFunction
	CombatLog_AddEvent = fakeFunction
	Blizzard_CombatLog_Refilter = fakeFunction
	COMBATLOG:SetScript("OnEvent", nil)

end

--Disable stuff
function YurrCombatLog:ADDON_LOADED(events, addonName)

	local events, addonName = events, addonName

	if addonName == "Blizzard_CombatLog" then
		--COMBATLOG:UnregisterEvent("COMBAT_LOG_EVENT")
		
		--CombatLogClearEntries()
		ChatFrame2:Clear()
		ChatFrame2:SetScript("OnUpdate", 
			function(self, elapsed)
				if CombatLogQuickButtonFrame_Custom:Hide() == 0 then return end
				CombatLogQuickButtonFrame_Custom:Hide()
				for i=1, COMBATLOG:GetNumPoints() do
				   point,relativeTo,relativePoint,xOfs,yOfs = COMBATLOG:GetPoint(i)
				   if ( point == "TOPLEFT" ) then 
				      break;
				   end
				end
				if ( COMBATLOG.isDocked ) then
				   COMBATLOG:SetPoint("TOPLEFT", relativeTo, relativePoint, 0, 0);
				end
				_G[COMBATLOG:GetName().."Background"]:SetPoint("TOPLEFT", COMBATLOG, "TOPLEFT", -2, 3);
				_G[COMBATLOG:GetName().."Background"]:SetPoint("TOPRIGHT", COMBATLOG, "TOPRIGHT", 2, 0);
			end
		)
		
		local count = CombatLogGetNumEntries();
		
		ChatFrame3:SetMaxLines(COMBATLOG_MESSAGE_LIMIT);
		
		-- count should be between 1 and COMBATLOG_MESSAGE_LIMIT
		--count = max(1, min(count, COMBATLOG_MESSAGE_LIMIT));
		
		CombatLogSetCurrentEntry(0);
		
		-- Clear the combat log
		ChatFrame2:Clear();
		ChatFrame3:Clear();
		for i = 1,count do 
			CombatLogSetCurrentEntry(i)
			YurrCombatLog:COMBAT_LOG_EVENT_UNFILTERED(arg1, CombatLogGetCurrentEntry())
		end


	end

end

--Hook stuff
function fakeFunction()
end

function YurrCombatLog:ChatFrame(frame)

	local frame = frame

	if frame == 1 then
		frame = ChatFrame1
	elseif frame == 2 then
		frame = ChatFrame2
	elseif frame == 3 then
		frame = ChatFrame3
	elseif frame == 4 then
		frame = ChatFrame4
	elseif frame == 5 then
		frame = ChatFrame5
	elseif frame == 6 then
		frame = ChatFrame6
	elseif frame == 7 then
		frame = ChatFrame7
	end
	return frame

end

function YurrCombatLog:ChatCommand(input)

	local input = input

	if not input or input:trim() == "" then
	  LibStub("AceConfigDialog-3.0"):Open("YurrCombatLog")
	else
	  LibStub("AceConfigCmd-3.0").HandleCommand(YurrCombatLog, "ycl", "YurrCombatLog", input)
	end

end

--credits to Kernelerror from my guild HappyFunRock
function YurrCombatLog:isChecked(event, sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)

	local event, sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName = event, sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName
	local unit, affiliation
	local filters = self.db.profile.filters
	local constants = self.db.profile.constants
	local sourceUnit = "source"
	local destUnit = "destination"
	local watches = self.db.profile.watches
	
	if ( watches[sourceName] ) then return true end
	if ( watches[destName] ) then return true end
	
	for key, value in pairs (constants) do
		value = tonumber(value)
		if CombatLog_Object_IsA(destFlags, value) or CombatLog_Object_IsA(sourceFlags, value) then
			--key = string.gsub(key, "is", "")
			affiliation = tostring(key)
			if affiliation then
				if ( filters[affiliation][destUnit][event] == true or filters[affiliation][sourceUnit][event] == true ) then
					return true
				end
			end
		end
	end
	
	--if it doesnt confirm to any IF statement
	return false;

end

	--Converts 4 floats into FF code
function YurrCombatLog:CombatLog_Color_FloatToText(r,g,b,a)

	local r,g,b,a = r,g,b,a
	if ( type(r) == "table" ) then
		r, g, b, a = r.r, r.g, r.b, r.a;
	end
	a = min(1, a or 1) * 255
	r = min(1, r) * 255
	g = min(1, g) * 255
	b = min(1, b) * 255
	
	-- local fmt = "%.2x";
	return ("%.2x%.2x%.2x%.2x"):format(math_floor(a), math_floor(r), math_floor(g), math_floor(b))

end

--Color unit by flags
function YurrCombatLog:colorUnit(name, flags)

	local name = name
	local flags = flags
	local playerColor
	local petColor
	local partyColor
	local raidColor
	local OutsiderColor
	local targetColor
	local focusColor
	
	local playerColored
	local petColored
	local partyColored
	local raidColored
	local OutsiderColored
	local targetColored
	local focusColored
	
	local colors = self.db.profile.colors
	local constants = self.db.profile.constants
	
	if CombatLog_Object_IsA(flags, constants.Player) then
		playerColor = self:CombatLog_Color_FloatToText(colors.player.r, colors.player.g, colors.player.b)
		playerColored = "|c"..playerColor..name.."|r"
		return playerColored
		
	elseif CombatLog_Object_IsA(flags, constants.Pet) then
		petColor = self:CombatLog_Color_FloatToText(colors.pet.r, colors.pet.g, colors.pet.b)
		petColored = "|c"..petColor..name.."|r"
		return petColored
		
	elseif CombatLog_Object_IsA(flags, constants.Guardian) then
		guardianColor = self:CombatLog_Color_FloatToText(colors.guardian.r, colors.guardian.g, colors.guardian.b)
		guardianColored = "|c"..guardianColor..name.."|r"
		return guardianColored
		
	elseif CombatLog_Object_IsA(flags, constants.Party) then
		partyColor = self:CombatLog_Color_FloatToText(colors.party.r, colors.party.g, colors.party.b)
		partyColored = "|c"..partyColor..name.."|r"
		return partyColored
		
	elseif CombatLog_Object_IsA(flags, constants.Raid) then
		raidColor = self:CombatLog_Color_FloatToText(colors.raid.r, colors.raid.g, colors.raid.b)
		raidColored = "|c"..raidColor..name.."|r"
		return raidColored
		
	elseif CombatLog_Object_IsA(flags, constants.Target) then
		targetColor = self:CombatLog_Color_FloatToText(colors.target.r, colors.target.g, colors.target.b)
		targetColored = "|c"..targetColor..name.."|r"
		return targetColored
		
	elseif CombatLog_Object_IsA(flags, constants.Outsider) then
		OutsiderColor = self:CombatLog_Color_FloatToText(colors.Outsider.r, colors.Outsider.g, colors.Outsider.b)
		OutsiderColored = "|c"..OutsiderColor..name.."|r"
		return OutsiderColored
		
	elseif CombatLog_Object_IsA(flags, constants.Focus) then
		focusColor = self:CombatLog_Color_FloatToText(colors.focus.r, colors.focus.g, colors.focus.b)
		focusColored = "|c"..focusColor..name.."|r"
		return focusColored
	end

end

function YurrCombatLog:SwingMissType(missType)

	local missType = missType
	local missed

	missed = (string.lower(missType))
	return missed

end

--Color anything via school
function YurrCombatLog:colorSpellName(school, name)

	local school, name = school, name
	local physical, holy, fire, nature, frost, shadow, arcane, natureshadow, newNameColored, nameColored
	local colors = self.db.profile.colors
	
	if type(name) == number then
		name = tostring(name)
	end
	
	if name == nil then
		name = L["Melee"]
	end

	if school == 1 then
		physical = self:CombatLog_Color_FloatToText(colors.physical.r, colors.physical.g, colors.physical.b)
		nameColored = "|c"..physical..name.."|r" --physical
	elseif school == 2 then
		holy = self:CombatLog_Color_FloatToText(colors.holy.r, colors.holy.g, colors.holy.b)
		nameColored = "|c"..holy..name.."|r" --holy
	elseif school == 4 then
		fire = self:CombatLog_Color_FloatToText(colors.fire.r, colors.fire.g, colors.fire.b)
		nameColored = "|c"..fire..name.."|r" --fire
	elseif school == 8 then
		nature = self:CombatLog_Color_FloatToText(colors.nature.r, colors.nature.g, colors.nature.b)
		nameColored = "|c"..nature..name.."|r" --nature
	elseif school == 16 then
		frost = self:CombatLog_Color_FloatToText(colors.frost.r, colors.frost.g, colors.frost.b)
		nameColored = "|c"..frost..name.."|r" --frost
	elseif school == 32 then
		shadow = self:CombatLog_Color_FloatToText(colors.shadow.r, colors.shadow.g, colors.shadow.b)
		nameColored = "|c"..shadow..name.."|r" --shadow
	elseif school == 40 then
		natureshadow = self:CombatLog_Color_FloatToText(colors.natureshadow.r, colors.natureshadow.g, colors.natureshadow.b)
		nameColored = "|c"..natureshadow..name.."|r" --arcane 
	elseif school == 64 then
		arcane = self:CombatLog_Color_FloatToText(colors.arcane.r, colors.arcane.g, colors.arcane.b)
		nameColored = "|c"..arcane..name.."|r" --arcane 
	end
	newNameColored = nameColored
	return newNameColored

end

--Color buffs by Buff/Debuff
function YurrCombatLog:buffColoring(buffName, buffType, amount)

	local buffName = buffName
	local buffType = buffType
	local amount = amount
	local buff
	local buffNameColored
	local buffColor
	local colors = self.db.profile.colors
	
	if buffType == "BUFF" or buffType == nil then
		buffColor = self:CombatLog_Color_FloatToText(colors.buff.r, colors.buff.g, colors.buff.b)
		
	elseif buffType == "DEBUFF" then
		buffColor = self:CombatLog_Color_FloatToText(colors.debuff.r, colors.debuff.g, colors.debuff.b)
	end
	
	buffNameColored = "|c"..buffColor.." ++ "..buffName.."AMOUNT|r"
	
	if (amount) then
		buffNameColored = string.gsub(buffNameColored, "(AMOUNT)", "("..amount..")")
	else
		buffNameColored = string.gsub(buffNameColored, "(AMOUNT)", (""))
	end
	
	return buffNameColored

end

--Color enchants
function YurrCombatLog:EnchantColoring(enchantName, eventType)

	local enchantName, eventType = enchantName, eventType
	local enchant, enchantNameColored
	local colors = self.db.profile.colors

	if eventType == "ENCHANT_APPLIED" then
		enchant = self:CombatLog_Color_FloatToText(colors.skill.r, colors.skill.g, colors.skill.b)
		enchantNameColored = "|c"..enchant..enchantName.."|r"
	elseif eventType == "ENCHANT_REMOVED" then
		enchant = self:CombatLog_Color_FloatToText(colors.skill.r, colors.skill.g, colors.skill.b)
		enchantNameColored = "|c"..enchant..enchantName.."|r"
	end
	return enchantNameColored

end

--returns environmental damage types
function YurrCombatLog:EnvironmentalDamageType(environmentalType)

	local environmentalType = environmentalType

	if environmentalType == "DROWNING" then
		environmentalType = "drown"
	elseif environmentalType == "FALLING" then
		environmentalType = "fall"
	elseif environmentalType == "FATIGUE" then
		environmentalType = "fatigue"
	elseif environmentalType == "FIRE" then
		environmentalType = "fire"
	elseif environmentalType == "LAVA" then
		environmentalType = "lava"
	elseif environmentalType == "SLIME" then
		environmentalType = "slime"
	end
	return environmentalType

end

-- NEEDS_IMPROVEMENT
function YurrCombatLog:powerType(powerType)

	local powerType = powerType

	if powerType == -2 then
		powerType = L["Health"] 
	elseif powerType == 0 then
		powerType = L["Mana"] 
	elseif powerType == 1 then
		powerType = L["Rage"]
	elseif powerType == 2 then
		powerType = L["Focus"]
	elseif powerType == 3 then
		powerType = L["Energy"]
	elseif powerType == 4 then
		powerType = L["Pet happiness "]
	end

end

-- Resists, etc...
function YurrCombatLog:partialDamage(resisted, blocked, absorbed, critical, glancing, crushing)

	local resisted = resisted
	local blocked = blocked
	local absorbed = absorbed
	local critical = critical
	local glancing = glancing
	local crushing = crushing
	local partialDamage
	
	if ( resisted ) then
		resisted = "(R"..resisted..")"
	else 
		resisted = ""
	end
	if ( blocked ) then
		blocked = "(B"..blocked..")"
	else 
		blocked = ""
	end
	if ( absorbed ) then
		absorbed = "(A"..absorbed..")"
	else 
		absorbed = ""
	end
	--[[if ( critical ) then
		critical = "Crit"
	else 
		critical = ""
	end]]
	if ( glancing ) then
		glancing = "(G)"
	else 
		glancing = ""
	end
	if ( crushing ) then
		crushing = "(C)"
	else 
		crushing = ""
	end
	
	partialDamage = resisted..blocked..absorbed..glancing..crushing
	return partialDamage

end

--parse the event
function YurrCombatLog:COMBAT_LOG_EVENT_UNFILTERED(arg1, timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)

	local colors = self.db.profile.colors
	local timestamp = timestamp
	local event = event
	local sourceGUID = sourceGUID
	local sourceName = sourceName
	local sourceFlags = sourceFlags
	local destGUID = destGUID
	local destName = destName
	local destFlags = destFlags
	local spellId
	local spellName
	local spellSchool
	local amount
	local school
	local resisted
	local blocked
	local absorbed
	local critical
	local glancing
	local crushing
	local source
	local dest
	local spellNameColored
	local meleeName
	local amountColored
	local damageType
	local missed
	local extraSpellId
	local extraSpellName
	local extraSpellSchool
	local extraSpellNameColored
	local environmentalType
	local partialDamage
	local missType
	local powerType
	local buffColor
	local auraType
	local buffNameColored
	local failType
	local itemID
	local itemName
	local enchantNameColored

	local output

	--sourceNameColored = self:colorUnit(sourceName, sourceFlags)
	--destNameColored = self:colorUnit(destName, destFlags)
	if ( self:isChecked(event, sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName) == false ) then
		return
	end

	if ( event == "SWING_DAMAGE" )  then
		amount, school, resisted, blocked, absorbed, critical, glancing, crushing = ...
		meleeName = self:colorSpellName(school)
		amountColored = self:colorSpellName(school, amount)
		partialDamage = self:partialDamage(resisted, blocked, absorbed, critical, glancing, crushing)
		if critical == 1 then critical = L["Crit "] amountColored = "*"..amountColored.."*" else critical = "" end
		output = "[SOURCE_NAME] "..meleeName.." "..critical.."[DEST_NAME] "..amountColored..partialDamage
		
	elseif ( event == "SWING_MISSED" )  then
		missType = ...
		missed = self:SwingMissType(missType)
		if missed == "miss" then
			output = "[SOURCE_NAME] "..missed.." [DEST_NAME] "
		else
			output = "[DEST_NAME] "..missed.." [SOURCE_NAME] "
		end
		
	elseif ( event == "RANGE_DAMAGE" )  then
		spellId, spellName, spellSchool, amount, school, resisted, blocked, absorbed, critical, glancing, crushing = ...
		amountColored = self:colorSpellName(spellSchool, amount)
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		partialDamage = self:partialDamage(resisted, blocked, absorbed, critical, glancing, crushing)
		if critical == 1 then critical = L["Crit "] amountColored = "*"..amountColored.."*" else critical = "" end
		output = "[SOURCE_NAME] "..spellNameColored.." "..critical.."[DEST_NAME] "..amountColored..partialDamage
		
	elseif ( event == "RANGE_MISSED" )  then
		spellId, spellName, spellSchool, missType = ...
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		missed = self:SwingMissType(missType)
		if missed == "miss" then
			output = "[SOURCE_NAME] "..spellNameColored.." "..missed.." [DEST_NAME]"
		else
			output = "[SOURCE_NAME] "..spellNameColored.." [DEST_NAME] "..missed
		end
		
	elseif ( event == "SPELL_DAMAGE" )  then
		spellId, spellName, spellSchool, amount, school, resisted, blocked, absorbed, critical, glancing, crushing = ...
		--spellNameColored = self:colorSpellName(spellSchool, spellName)
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		amountColored = self:colorSpellName(spellSchool, amount)
		partialDamage = self:partialDamage(resisted, blocked, absorbed, critical, glancing, crushing)
		if critical == 1 then critical = L["Crit "] amountColored = "*"..amountColored.."*" else critical = "" end
		output = "[SOURCE_NAME] "..spellNameColored.." "..critical.."[DEST_NAME] "..amountColored..partialDamage
		
	elseif ( event == "SPELL_MISSED" )  then
		spellId, spellName, spellSchool, missType = ...
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		missed = self:SwingMissType(missType)
		if missed == "miss" then
			output = "[SOURCE_NAME] "..spellNameColored.." "..missed.." [DEST_NAME]"
		else
			output = "[SOURCE_NAME] "..spellNameColored.." [DEST_NAME] "..missed
		end
		
	elseif ( event == "SPELL_HEAL" )  then
		spellId, spellName, spellSchool, amount, critical = ...
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		amountColored = self:colorSpellName(spellSchool, amount)
		if critical == 1 then critical = "Crit " amountColored = "*"..amountColored.."*" else critical = "" end
		output = "[SOURCE_NAME] "..spellNameColored.." "..critical.."[DEST_NAME] "..amountColored
		
	elseif ( event == "SPELL_ENERGIZE" )  then
		spellId, spellName, spellSchool, amount, powerType = ...
		if powerType == -2 then powerType = L["Health"] elseif powerType == 0 then powerType = L["Mana"] elseif powerType == 1 then powerType = L["Rage"] elseif powerType == 2 then powerType = L["Focus"] elseif powerType == 3 then powerType = L["Energy"] elseif powerType == 4 then powerType = L["Pet happiness "] end
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		amountColored = self:colorSpellName(spellSchool, amount)
		if critical == 1 then critical = L["Crit "] amountColored = "*"..amountColored.."*" else critical = "" end
		output = "[SOURCE_NAME] "..spellNameColored.." : [DEST_NAME] + "..amountColored.." "..powerType
		
	elseif ( event == "SPELL_PERIODIC_MISSED" )  then
		spellId, spellName, spellSchool, missType = ...
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		missed = self:SwingMissType(missType)
		if missed == " miss " then
			output = "[SOURCE_NAME] "..spellNameColored..missed.." [DEST_NAME]"
		else
			output = "[SOURCE_NAME] "..spellNameColored.." [DEST_NAME] "..missed
		end
		
	elseif ( event == "SPELL_PERIODIC_DAMAGE" )  then
		spellId, spellName, spellSchool, amount, school, resisted, blocked, absorbed, critical, glancing, crushing = ...
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		amountColored = self:colorSpellName(school, amount)
		partialDamage = self:partialDamage(resisted, blocked, absorbed, critical, glancing, crushing)
		if critical == 1 then critical = L["Crit "] amountColored = "*"..amountColored.."*" else critical = "" end
		output = "[SOURCE_NAME] "..spellNameColored.." "..critical..L["Dot"].." [DEST_NAME] ~"..amountColored.."~"..partialDamage
		
	elseif ( event == "SPELL_PERIODIC_HEAL" )  then
		spellId, spellName, spellSchool, amount, critical = ...
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		amountColored = self:colorSpellName(spellSchool, amount)
		if critical == 1 then critical = L["Crit "] amountColored = "*"..amountColored.."*" else critical = "" end
		output = "[SOURCE_NAME] "..spellNameColored.." "..critical..L["regen"].." [DEST_NAME] ~"..amountColored.."~"
		
	elseif ( event == "SPELL_PERIODIC_DRAIN" )  then
		spellId, spellName, spellSchool, amount, powerType, extraAmount = ...
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		amountColored = self:colorSpellName(spellSchool, amount)
		if critical == 1 then critical = L["Crit "] amountColored = "*"..amountColored.."*" else critical = "" end
		output = "[SOURCE_NAME] "..spellNameColored.." "..critical..L["Drain"].." [DEST_NAME] ~"..amountColored.."~"
		
	elseif ( event == "SPELL_PERIODIC_LEECH" )  then
		spellId, spellName, spellSchool, amount, powerType, extraAmount = ...
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		amountColored = self:colorSpellName(spellSchool, amount)
		if critical == 1 then critical = L["Crit "] amountColored = "*"..amountColored.."*" else critical = "" end
		output = "[SOURCE_NAME] "..spellNameColored.." "..critical..L["Leech"].." [DEST_NAME] ~"..amountColored.."~"
		
	elseif ( event == "SPELL_PERIODIC_ENERGIZE" )  then
		spellId, spellName, spellSchool, amount, powerType = ...
		if powerType == -2 then powerType = L["Health"] elseif powerType == 0 then powerType = L["Mana"] elseif powerType == 1 then powerType = L["Rage"] elseif powerType == 2 then powerType = L["Focus"] elseif powerType == 3 then powerType = L["Energy"] elseif powerType == 4 then powerType = L["Pet happiness "] end
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		amountColored = self:colorSpellName(spellSchool, amount)
		if critical == 1 then critical = L["Crit "] amountColored = "*"..amountColored.."*" else critical = "" end
		output = "[SOURCE_NAME] "..spellNameColored.." : [DEST_NAME] + "..amountColored.." "..powerType
		
	elseif ( event == "SPELL_DRAIN" )  then
		spellId, spellName, spellSchool, amount, powerType, extraAmount = ...
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		amountColored = self:colorSpellName(spellSchool, amount)
		if critical == 1 then critical = L["Crit "] amountColored = "*"..amountColored.."*" else critical = "" end
		output = "[SOURCE_NAME] "..spellNameColored.." "..critical..L["Drain"].." [DEST_NAME] "..amountColored
		
	elseif ( event == "SPELL_LEECH" )  then
		spellId, spellName, spellSchool, amount, powerType, extraAmount = ...
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		amountColored = self:colorSpellName(spellSchool, amount)
		if critical == 1 then critical = L["Crit "] amountColored = "*"..amountColored.."*" else critical = "" end
		output = "[SOURCE_NAME] "..spellNameColored.." "..critical..L["Leech"].." [DEST_NAME] "..amountColored
		
	elseif ( event == "SPELL_INTERRUPT" )  then
		spellId, spellName, spellSchool, extraSpellId, extraSpellName, extraSpellSchool = ...
		buffColor = self:CombatLog_Color_FloatToText(colors.skill.r, colors.skill.g, colors.skill.b)
		extraSpellNameColored = self:colorSpellName(extraSpellSchool, extraSpellName)
		output = "[SOURCE_NAME] |c"..buffColor..L["interrupt"].."|r [DEST_NAME] "..extraSpellNameColored
		
	elseif ( event == "SPELL_EXTRA_ATTACKS" )  then
		spellId, spellName, spellSchool, amount = ...
		amountColored = self:colorSpellName(spellSchool, amount)
		output = "[SOURCE_NAME] "..L["+ 1 attacks"].." ("..amountColored..")"
		
	elseif ( event == "SPELL_INSTAKILL" ) then
		spellId, spellName, spellSchool = ...
		
	elseif ( event == "SPELL_DURABILITY_DAMAGE" ) then
		spellId, spellName, spellSchool = ...
		
	elseif ( event == "SPELL_DURABILITY_DAMAGE_ALL" ) then
		spellId, spellName, spellSchool = ...
		
	elseif ( event == "SPELL_DISPEL_FAILED" )  then
		spellId, spellName, spellSchool, extraSpellId, extraSpellName, extraSpellSchool = ...
		extraSpellNameColored = self:colorSpellName(extraSpellSchool, extraSpellName)
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		output = "[SOURCE_NAME] "..spellNameColored.." "..extraSpellNameColored.." [DEST_NAME]"..L["failed"]
		
	elseif ( event == "SPELL_DISPELL" )  then
		spellId, spellName, spellSchool, extraSpellId, extraSpellName, extraSpellSchool, auraType = ...
		extraSpellNameColored = self:colorSpellName(extraSpellSchool, extraSpellName)
		output = "[SOURCE_NAME] "..L["dispel "]..extraSpellNameColored.." [DEST_NAME]"
		
	elseif ( event == "SPELL_STOLEN" ) then
		spellId, spellName, spellSchool, extraSpellId, extraSpellName, extraSpellSchool, auraType = ...
		
	elseif ( event == "SPELL_AURA_APPLIED" )  then
		spellId, spellName, spellSchool, auraType = ...
		--(source arguments are nil)
		buffNameColored = self:buffColoring(spellName, auraType, nil)
		output = "[DEST_NAME]"..buffNameColored
		
	elseif ( event == "SPELL_AURA_REMOVED" )  then
		spellId, spellName, spellSchool, auraType = ...
		--(source arguments are nil)
		buffColor = self:CombatLog_Color_FloatToText(colors.skill.r, colors.skill.g, colors.skill.b)
		output = "[DEST_NAME]".."|c"..buffColor.." -- "..spellName.."|r"
		
	elseif ( event == "SPELL_AURA_APPLIED_DOSE" )  then
		spellId, spellName, spellSchool, auraType, amount = ...
		--(source arguments are nil)
		buffNameColored = self:buffColoring(spellName, auraType, amount)
		output = "[DEST_NAME]"..buffNameColored
		
	elseif ( event == "SPELL_AURA_REMOVED_DOSE" )  then
		spellId, spellName, spellSchool, auraType, amount = ...
		--(source arguments are nil)
		buffColor = self:CombatLog_Color_FloatToText(colors.skill.r, colors.skill.g, colors.skill.b)
		output = "[DEST_NAME]".."|c"..buffColor.." -- "..spellName.."("..amount..")|r"
		
	elseif ( event == "SPELL_CAST_START" ) then
		spellId, spellName, spellSchool = ...
		
	elseif ( event == "SPELL_CAST_SUCCESS" ) then
		spellId, spellName, spellSchool = ...
		
	elseif ( event == "SPELL_CAST_FAILED" )  then
		spellId, spellName, spellSchool, failType = ...
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		output = spellNameColored..L[" Fail"]..": "..failType
		
		--Special Events
	elseif ( event == "DAMAGE_SHIELD" )  then
		spellId, spellName, spellSchool, amount, school, resisted, blocked, absorbed, critical, glancing, crushing = ...
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		amountColored = self:colorSpellName(spellSchool, amount)
		buffNameColored = self:buffColoring(spellName, auraType, amount)
		partialDamage = self:partialDamage(resisted, blocked, absorbed, critical, glancing, crushing)
		if critical == 1 then critical = L["Crit "] amountColored = "*"..amountColored.."*" else critical = "" end
		output = "[SOURCE_NAME] "..spellNameColored.." "..critical.."[DEST_NAME] "..amountColored..partialDamage
		
	elseif ( event == "DAMAGE_SPLIT" ) then
		spellId, spellName, spellSchool, amount, school, resisted, blocked, absorbed, critical, glancing, crushing = ...
		
	elseif ( event == "DAMAGE_SHIELD_MISSED" )  then
		spellId, spellName, spellSchool, missType = ...
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		missed = self:SwingMissType(missType)
		output = "[SOURCE_NAME] "..spellNameColored.." [DEST_NAME] "..missed
		
	elseif ( event == "ENCHANT_APPLIED" )  then
		spellName, itemID, itemName = ...
		enchantNameColored = self:EnchantColoring(spellName, event)
		output = L["Enchant"]..": [SOURCE_NAME] "..enchantNameColored..L[" to"].." [DEST_NAME] "..itemName
		
	elseif ( event == "ENCHANT_REMOVED" )  then
		spellName, itemID, itemName = ...
		enchantNameColored = self:EnchantColoring(spellName, event)
		output = L["Enchant"]..": [DEST_NAME] "..enchantNameColored..L[" fades from: "]..itemName
		
	elseif ( event == "PARTY_KILL" )  then
		output = "[SOURCE_NAME] "..L["killed"].." [DEST_NAME]"
		
	elseif ( event == "UNIT_DESTROYED" ) then
		output = L["Death"]..": [DEST_NAME]"
		
	elseif ( event == "UNIT_DIED" ) then
		output = L["Death"]..": [DEST_NAME]"
		
	elseif ( event == "ENVIRONMENTAL_DAMAGE" )  then
		environmentalType, amount, school, resisted, blocked, absorbed, critical, glancing, crushing = ...
		environmentalType = self:EnvironmentalDamageType(environmentalType)
		amountColored = self:colorSpellName(school, amount)
		partialDamage = self:partialDamage(resisted, blocked, absorbed, critical, glancing, crushing)
		output = "[DEST_NAME] "..environmentalType.." "..amountColored..partialDamage
	end
	
	if ( output ) then
		self:AddOutput(output, timestamp, sourceName, sourceFlags, destName, destFlags)
	end

end

--Add message to chatframe
function YurrCombatLog:AddOutput( output, timestamp,sourceName, sourceFlags, destName, destFlags)

	local timestamp, sourceName, sourceFlags, destName, destFlags = timestamp, sourceName, sourceFlags, destName, destFlags
	local output = output
	local timestampColor, source, dest
	local colors = self.db.profile.colors
	local timestampDB = self.db.profile.timestamp

	if ( timestampDB == true ) then
		timestampColor = self:CombatLog_Color_FloatToText(colors.timestampColor.r, colors.timestampColor.g, colors.timestampColor.b)
		timestamp = "|c"..timestampColor..date("[%H:%M:%S]", timestamp).."|r"
		output = timestamp..output
		timestamp = nil
	end
	source = self:colorUnit(sourceName, sourceFlags)
	dest = self:colorUnit(destName, destFlags)
	if (source) then
		output = string.gsub(output, "(SOURCE_NAME)", source)
	else 
		output = string.gsub(output, "(SOURCE_NAME)", "N/A")
	end
	if (dest) then
		output = string.gsub(output, "(DEST_NAME)", dest)
	end
	output = string.gsub(output, (UnitName("Player")), "You")
	outputFrame:AddMessage(output)

end

--Experience
function YurrCombatLog:CHAT_MSG_COMBAT_XP_GAIN(event, fullexp)

	local event, fullexp = event, fullexp
	local start, stop, amount, source, totalbonus, bonus, bonustype, group, output
	local experienceEvent = self.db.profile.events.experience
	local COMBATLOG_XPGAIN_FIRSTPERSON_UNNAMED = COMBATLOG_XPGAIN_FIRSTPERSON_UNNAMED
	local COMBATLOG_XPGAIN_FIRSTPERSON = COMBATLOG_XPGAIN_FIRSTPERSON
	local COMBATLOG_XPGAIN_EXHAUSTION1 = COMBATLOG_XPGAIN_EXHAUSTION1
	local COMBATLOG_XPGAIN_FIRSTPERSON_GROUP = COMBATLOG_XPGAIN_FIRSTPERSON_GROUP
	local COMBATLOG_XPGAIN_EXHAUSTION1_GROUP = COMBATLOG_XPGAIN_EXHAUSTION1_GROUP
	
	if( experienceEvent == true ) then
		-- Quest
		-- You gain %d experience.
		experience = string.gsub(COMBATLOG_XPGAIN_FIRSTPERSON_UNNAMED, "(%%d)", "(.+)")
		start, stop, amount = string.find(fullexp, experience)
		if (amount) then
			output = L["Exp: "]..amount
		end
		
		-- Solo
		-- %s dies, you gain %d experience.
		experience = string.gsub(string.gsub(COMBATLOG_XPGAIN_FIRSTPERSON, "(%%s)", "(.+)"), "(%%d)", "(.+)")
		start, stop, source, amount = string.find(fullexp, experience)
		if (amount) then
			if (source) then
				output = L["Exp: "]..amount.."("..source..")"
			end
		end
		
		-- Solo rested
		-- %s dies, you gain %d experience. (%s exp %s bonus)
		experience = string.gsub(string.gsub(string.gsub(string.gsub(COMBATLOG_XPGAIN_EXHAUSTION1, "(%%s)", "(.+)"), "(%%d)", "(.+)"), "(%%s)", "(.+)"), "(%%s)", "(.+)");
		start, stop, source, amount, totalbonus, bonus, bonustype = string.find(fullexp, experience);
		if (amount) then
			if (source) then
				if (bonus) then
					bonus = string.sub(bonus, string.find(bonus, "+%d+", start))
					output = L["Exp: "]..amount.."("..source..")("..bonustype..bonus..")"
				end
			end
		end
		
		-- Grouped
		-- %s dies, you gain %d experience. (+%d group bonus)
		experience = string.gsub(string.gsub(string.gsub(COMBATLOG_XPGAIN_FIRSTPERSON_GROUP, "(%%s)", "(.+)"), "(%%d)", "(.+)"), "(%%d)", "(.+)")
		start, stop, source, amount, group = string.find(fullexp, experience)
		if (amount) then
			if (source) then
				if (group) then
					group = string.sub(group, string.find(group, "%d+", start))
					output = L["Exp: "]..amount.."("..source..")("..L["G+"]..group..")"
				end
			end
		end
		
		-- Grouped rested
		-- %s dies, you gain %d experience. (%s exp %s bonus, +%d group bonus)
		experience = string.gsub(string.gsub(string.gsub(string.gsub(COMBATLOG_XPGAIN_EXHAUSTION1_GROUP, "(%%s)", "(.+)"), "(%%d)", "(.+)"), "(%%s)", "(.+)"), "(%%d)", "(.+)")
		start, stop, source, amount, totalbonus, bonus, bonustype, group = string.find(fullexp, experience)
		if (amount) then
			if (source) then
				if (bonus) then
					if (group) then
						bonus = string.sub(bonus, string.find(bonus, "+%d+", start))
						group = string.sub(group, string.find(group, "%d+", start))
						output = L["Exp: "]..amount.."("..source..")("..bonustype..bonus..")("..L["G+"]..group..")"
					end
				end
			end
		end
		self:AddOutput(output, nil)
	end

end

--Honor
function YurrCombatLog:CHAT_MSG_COMBAT_HONOR_GAIN(event, fullhonor)

	local event, fullhonor = event, fullhonor
	local honor, start, stop, amount, source, output, rank
	local honorEvent = self.db.profile.events.honor
	local COMBATLOG_HONORAWARD = COMBATLOG_HONORAWARD
	local COMBATLOG_HONORGAIN = COMBATLOG_HONORGAIN

	if ( honorEvent == true ) then
		-- Honor
		-- You have been awarded %d honor points.
		honor = string.gsub(COMBATLOG_HONORAWARD, "(%%d)", "(.+)")
		start, stop, amount = string.find(fullhonor, honor)
		if (amount) then
		   output = L["Honor: "]..amount
		end
		
		-- HonorKill
		-- %s dies, honorable kill Rank: %s (%d Honor Points)
		honor = string.gsub(string.gsub(string.gsub(COMBATLOG_HONORGAIN, "(%%s)", "(.+)"), "(%%s)", "(.+)"), "(%%d)", "(.+)")
		start, stop, source, rank, _, amount = string.find(fullhonor, honor)
		if (source) then
		   if (rank) then
		      if (amount) then
		         amount = string.sub(amount, string.find(amount, "%d+", start))
		         output = L["Honor: "]..amount.." ("..rank.." "..source..")"
		      end
		   end
		end
		self:AddOutput(output, nil)
	end

end

--Reputation
function YurrCombatLog:CHAT_MSG_COMBAT_FACTION_CHANGE(event, fullrep)

	local event, fullrep = event, fullrep
	local gain, start, stop, faction, amount, output
	local factionEvent = self.db.profile.events.faction
	local FACTION_STANDING_INCREASED = FACTION_STANDING_INCREASED
	local FACTION_STANDING_DECREASED = FACTION_STANDING_DECREASED

	if( factionEvent == true ) then
		-- Reputation with %s increased by %d.
		gain = string.gsub(string.gsub(FACTION_STANDING_INCREASED, "(%%s)", "(.+)"), "(%%d)", "(.+)")
		start, stop, faction, amount = string.find(fullrep, gain)
		if (faction) then
			if (amount) then
				output = L["Rep: "]..faction.." +"..amount
			end
		end
		
		-- Reputation with %s decreased by %d.
		gain = string.gsub(string.gsub(FACTION_STANDING_DECREASED, "(%%s)", "(.+)"), "(%%d)", "(.+)")
		start, stop, faction, amount = string.find(fullrep, gain)
		if (faction) then
			if (amount) then
				output = L["Rep: "]..faction.." -"..amount
				gain, faction, amount = nil, nil, nil
			end
		end

	self:AddOutput(output, nil)
	end

end

--Skillups
function YurrCombatLog:CHAT_MSG_SKILL(event, fullSkillup)

	local event, fullSkillup = event, fullSkillup
	local start, stop, skill, amount, skillup, output
	local skillEvent = self.db.profile.events.skill
	local ERR_SKILL_UP_SI = ERR_SKILL_UP_SI

	if ( skillEvent == true ) then
		-- Skillup
		-- Your skill in %s has increased to %d.
		skillup = string.gsub(string.gsub(ERR_SKILL_UP_SI, "(%%s)", "(.+)"), "(%%d)", "(.+)")
		start, stop, skill, amount = string.find(fullSkillup, skillup)
		if (skill) then
			if (amount) then
				output = L["Skill: "]..skill.."("..amount..")"
				self:AddOutput(output, nil)
			end
		end
	end

end

--Combat
function YurrCombatLog:PLAYER_REGEN_ENABLED()

	local output
	local combat = self.db.profile.events.combat
	
	if combat == true then
		output = " -- "..L["Combat"]
		self:AddOutput(output, nil)
	end

end
function YurrCombatLog:PLAYER_REGEN_DISABLED()

	local output
	local combat = self.db.profile.events.combat
	
	if combat == true then
		output = " ++ "..L["Combat"]
		self:AddOutput(output, nil)
	end

end

function YurrCombatLog:getColor(info)
	return self.db.profile.colors[info[#info]].r, self.db.profile.colors[info[#info]].g, self.db.profile.colors[info[#info]].b
end
function YurrCombatLog:setColor(info, r, g, b)
	self.db.profile.colors[info[#info]] = { ["r"]=r, ["g"]=g, ["b"]=b }
end

function YurrCombatLog:getFilter(info)
	return self.db.profile.filters[info[#info-2]][info[#info-1]][info[#info]]
end
function YurrCombatLog:setFilter(info, value)
	self.db.profile.filters[info[#info-2]][info[#info-1]][info[#info]] = value
end
function YurrCombatLog:addFilter(info, value)

	self.db.profile.filters[value] = {
		source = {
			SWING_DAMAGE = false,
			SWING_MISSED = false,
			RANGE_DAMAGE = false,
			RANGE_MISSED = false,
			SPELL_DAMAGE = false,
			SPELL_MISSED = false,
			SPELL_HEAL = false,
			SPELL_ENERGIZE = false,
			SPELL_PERIODIC_MISSED = false,
			SPELL_PERIODIC_DAMAGE = false,
			SPELL_PERIODIC_HEAL = false,
			SPELL_PERIODIC_DRAIN = false,
			SPELL_PERIODIC_LEECH = false,
			SPELL_PERIODIC_ENERGIZE = false,
			SPELL_DRAIN = false,
			SPELL_LEECH = false,
			SPELL_INTERRUPT = false,
			SPELL_EXTRA_ATTACKS = false,
			SPELL_INSTAKILL = false,
			SPELL_DURABILITY_DAMAGE = false,
			SPELL_DURABILITY_DAMAGE_ALL = false,
			SPELL_DISPELL = false,
			SPELL_STOLEN = false,
			SPELL_AURA_APPLIED = false,
			SPELL_AURA_REMOVED = false,
			SPELL_AURA_APPLIED_DOSE = false,
			SPELL_AURA_REMOVED_DOSE = false,
			SPELL_CAST_START = false,
			SPELL_CAST_SUCCESS = false,
			SPELL_CAST_FAILED = false,
			DAMAGE_SHIELD = false,
			DAMAGE_SPLIT = false,
			DAMAGE_SHIELD_MISSED = false,
			ENCHANT_APPLIED = false,
			ENCHANT_REMOVED = false,
			PARTY_KILL = false,
			UNIT_DESTROYED = false,
			UNIT_DIED = false,
			ENVIRONMENTAL_DAMAGE = false,
		},
		destination = {
			SWING_DAMAGE = false,
			SWING_MISSED = false,
			RANGE_DAMAGE = false,
			RANGE_MISSED = false,
			SPELL_DAMAGE = false,
			SPELL_MISSED = false,
			SPELL_HEAL = false,
			SPELL_ENERGIZE = false,
			SPELL_PERIODIC_MISSED = false,
			SPELL_PERIODIC_DAMAGE = false,
			SPELL_PERIODIC_HEAL = false,
			SPELL_PERIODIC_DRAIN = false,
			SPELL_PERIODIC_LEECH = false,
			SPELL_PERIODIC_ENERGIZE = false,
			SPELL_DRAIN = false,
			SPELL_LEECH = false,
			SPELL_INTERRUPT = false,
			SPELL_EXTRA_ATTACKS = false,
			SPELL_INSTAKILL = false,
			SPELL_DURABILITY_DAMAGE = false,
			SPELL_DURABILITY_DAMAGE_ALL = false,
			SPELL_DISPELL = false,
			SPELL_STOLEN = false,
			SPELL_AURA_APPLIED = false,
			SPELL_AURA_REMOVED = false,
			SPELL_AURA_APPLIED_DOSE = false,
			SPELL_AURA_REMOVED_DOSE = false,
			SPELL_CAST_START = false,
			SPELL_CAST_SUCCESS = false,
			SPELL_CAST_FAILED = false,
			DAMAGE_SHIELD = false,
			DAMAGE_SPLIT = false,
			DAMAGE_SHIELD_MISSED = false,
			ENCHANT_APPLIED = false,
			ENCHANT_REMOVED = false,
			PARTY_KILL = false,
			UNIT_DESTROYED = false,
			UNIT_DIED = false,
			ENVIRONMENTAL_DAMAGE = false,
		}
	}
	self:ParseFilters()

end

function YurrCombatLog:getEvents(info)
	return self.db.profile[info[#info-1]][info[#info]]
end
function YurrCombatLog:setEvents(info, value)
	self.db.profile[info[#info-1]][info[#info]] = value
end

function YurrCombatLog:setFlags(info, value)
	local result = 0
	local flags = self.db.profile.flags
	if value == false then
		self.db.profile.flags[info[#info-3]][info[#info]] = nil
	elseif value == true then
		if flags[info[#info-3]] == nil then 
			self.db.profile.flags[info[#info-3]] = {}
		end
		self.db.profile.flags[info[#info-3]][info[#info]] = info[#info]
	end
	for key, v in pairs (flags[info[#info-3]]) do
		key = tonumber(v)
		result = bit.bor(result, key)
	end
	self.db.profile.constants[info[#info-3]] = result
end
function YurrCombatLog:getFlags(info)
	if self.db.profile.flags[info[#info-3]] then
		if self.db.profile.flags[info[#info-3]][info[#info]] then
			return true
		end
	end
end


-- Copyright 2008 Copystring"